#! ../guile-fltk \
-s
!#

; boxtype.scm
; This script is functionally equivalent to the boxtype.cxx
; program included in the Fltk test directory.

(define N 0)
(define W 150)
(define H 50)
(define ROWS 8)

(define bt 
  (lambda (name type)
    (define x (floor (modulo N 4)))
    (define y (floor (/ N 4)))
    (set! N (+ N 1))
    (set! x (+ 10 (* x W)))
    (set! y (+ 10 (* y H)))
    (define box (fltk-box-new type (round x) (round y) (- W 20) (- H 20) name))
    (fltk-box-set-labelsize box 11)))

(define window (fltk-window-new "Box Type Demo" #:w (* 4 W) #:h (* ROWS H)))
(fltk-window-set-box window FL-FLAT-BOX)
(fltk-window-set-color window 12) ; light blue
(bt "FL-NO-BOX" FL-NO-BOX)
(bt "FL-FLAT-BOX" FL-FLAT-BOX)
(set! N (+ N 2))
(bt "FL-UP-BOX" FL-UP-BOX)
(bt "FL-DOWN-BOX" FL-DOWN-BOX)
(bt "FL-UP-FRAME" FL-UP-FRAME)
(bt "FL-DOWN-FRAME" FL-DOWN-FRAME)
(bt "FL-THIN-UP-BOX" FL-THIN-UP-BOX)
(bt "FL-THIN-DOWN-BOX" FL-THIN-DOWN-BOX)
(bt "FL-THIN-UP-FRAME" FL-THIN-UP-FRAME)
(bt "FL-THIN-DOWN-FRAME" FL-THIN-DOWN-FRAME)
(bt "FL-ENGRAVED-BOX" FL-ENGRAVED-BOX)
(bt "FL-EMBOSSED-BOX" FL-EMBOSSED-BOX)
(bt "FL-ENGRAVED-FRAME" FL-ENGRAVED-FRAME)
(bt "FL-EMBOSSED-FRAME" FL-EMBOSSED-FRAME)
(bt "FL-BORDER-BOX" FL-BORDER-BOX)
(bt "FL-SHADOW-BOX" FL-SHADOW-BOX)
(bt "FL-BORDER-FRAME" FL-BORDER-FRAME)
(bt "FL-SHADOW-FRAME" FL-SHADOW-FRAME)
(bt "FL-ROUNDED-BOX" FL-ROUNDED-BOX)
(bt "FL-RSHADOW-BOX" FL-RSHADOW-BOX)
(bt "FL-ROUNDED-FRAME" FL-ROUNDED-FRAME)
(bt "FL-RFLAT-BOX" FL-RFLAT-BOX)
(bt "FL-OVAL-BOX" FL-OVAL-BOX)
(bt "FL-OSHADOW-BOX" FL-OSHADOW-BOX)
(bt "FL-OVAL-FRAME" FL-OVAL-FRAME)
(bt "FL-OFLAT-BOX" FL-OFLAT-BOX)
(bt "FL-ROUND-UP-BOX" FL-ROUND-UP-BOX)
(bt "FL-ROUND-DOWN-BOX" FL-ROUND-DOWN-BOX)
(bt "FL-DIAMOND-UP-BOX" FL-DIAMOND-UP-BOX)
(bt "FL-DIAMOND-DOWN-BOX" FL-DIAMOND-DOWN-BOX)
(fltk-window-set-resizable window window)
(fltk-window-end window)
(fltk-window-show window)
(fltk-run)

