#!../guile-fltk \
-e main -s 
!#

; browser.scm
; This script is functionally equivalent to the browser.cxx
; program included in the Fltk test directory.

#!
This is a test of how the browser draws lines.
This is a second line.
This is a third.

That was a blank line above this.

@r@_Right justify
@c@_Center justify
@_Left justify

@bBold text
@iItalic text
@b@iBold Italic
@fFixed width
@f@bBold Fixed
@f@iItalic Fixed
@f@i@bBold Italic Fixed
@lLarge
@l@bLarge bold
@sSmall
@s@bSmall bold
@s@iSmall italic
@s@i@bSmall italic bold
@uunderscore
@C1RED
@C2Green
@C4Blue

        You should try different browser types:
        Fl_Browser
        Fl_Select_Browser
        Fl_Hold_Browser
        Fl_Multi_Browser
!#

(define print 
  (lambda args
    (for-each (lambda (a) (display a)) args)))

(define browser-callback
  (lambda (widget data)
    (print "callback, selection = " 
	   (fltk-select-browser-get-value widget)
	   ", event_clicks = " 
	   (fltk-event-clicks) "\n")))

(define fname "browser.scm")

(define (main args)
  (if (not (null? (cdr args)))
      (set! fname (cadr args)))

  (define window (fltk-window-new fname #:w 400 #:h 400))
  (fltk-window-set-box window FL-NO-BOX)
  (define browser (fltk-select-browser-new 0 0 400 400 ""))
  (fltk-browser-set-callback browser browser-callback)
  (fltk-select-browser-set-type browser FL-MULTI-BROWSER)
  (if (not (fltk-browser-load browser fname))
      (begin
	(print "Can't load " fname ", x\n")
	(exit)))
  (fltk-browser-set-position browser 0)
  (fltk-window-set-resizable window browser)
  (fltk-window-show window)
  (fltk-run))
