class ClassArray
{
 public:
  ClassArray()
    {
      _size = 0; 
      _data = NULL; 
    }

  ClassArray(long n) 
    {
      _size = 0;
      _data = NULL;
      append(n);
    }

  ~ClassArray() { reset(); }
  class_entry *& first() { return _data[0]; }
  class_entry *& last() { return _data[_size-1]; }
  class_entry *& operator[](long i) { return _data[i]; }

  class_entry *& append(long s) 
    {
      class_entry** t;
      t = new class_entry*[_size+s];
      for ( register long i=0; i<_size; i++)
	t[i] = _data[i];
      if (_size > 0) 
	delete[] _data;
      _data = t;
      _size = _size + s;
      return _data[_size-s];
    }

  class_entry *& append() { return append(1); }

  void remove(long n, long s)
    {
      class_entry** t;
      register long i;
      
      t = new class_entry*[_size - s];
      
      for (i=0; i<n; i++)
	t[i] = _data[i];
      
      for (i=n+s; i<_size; i++)
	t[i-s] = _data[i];
      
      delete[] _data;
      _data = t;
      _size = _size - n + s;
    }
  
  void remove(long n) { remove (_size-n, n); }
  void shrink(long s) { remove (_size - s, s); }
  
  void shrink()
    {
      class_entry** t;
   
      _size--;
      t = new class_entry*[_size];
      
      for (register long i=0; i<_size; i++)
	t[i] = _data[i];
      
      delete[] _data;
      _data = t;
    }

  void reset ()
    {
      delete[] _data;
      _data = NULL;
      _size = 0;
    }

  class_entry*& insert(long n, long s)
    {
      register long i;
      class_entry** t;
      
      t = new class_entry*[_size+s];

      for (i=0; i<n; i++)
	t[i] = _data[i];
      
      for (i=n+s; i<_size; i++)
	t[i] = _data[i-s];
      
      delete[] _data;
      _data = t;
      _size = _size - n + s;
      return _data[n];
    }

  long size() { return _size; }

  void resize(long s) { remove (s, _size-s); }

  class_entry** buffer() { return _data; }

  void operator = (ClassArray &a2)
    {
      reset();
      append(a2.size());
      
      for ( register long i = 0; i < a2.size(); i++) 
        _data[i] = a2[i];
    }

 private:
  class_entry ** _data;
  long _size;
};

