#ifndef FLTK_GUILE
#define FLTK_GUILE 1
#include <libguile.h>
#include <guile/gh.h>
#include <FL/Fl_Widget.H>

#define GUILE_FLTK_MAJOR 0
#define GUILE_FLTK_MINOR 1
#define GUILE_FLTK_PATCH 2

typedef SCM (*guilefp)(...);

extern "C" 
{
  extern void scm_init_gfltk_module();
  extern void scm_init_gfltk();
}

extern void gfltk_export_object (char *name, Fl_Widget *widget, 
				 long widget_tag);

void guile_fltk_callback(Fl_Widget *, void*);
void guile_fltk_callback2(Fl_Widget *, void *);

class Gfltk 
{
 public:
  Gfltk(SCM);
  Gfltk() {};
  ~Gfltk();
  void callback(SCM);
  void callback_argument(SCM);
  void unprotect();
  SCM callback();
  SCM widget_smob;
  Fl_Widget *widget;
 private:
  SCM widget_callback;
  SCM widget_callback_argument;
};

extern long fltk_widget_tag;
extern long fltk_window_tag;
extern long fltk_group_tag;
extern long fltk_tile_tag;
extern long fltk_menu_tag;
extern long fltk_menu_bar_tag;
extern long fltk_browser_base_tag;
extern long fltk_browser_tag;
extern long fltk_hold_browser_tag;
extern long fltk_select_browser_tag;
extern long fltk_multi_browser_tag;
extern long fltk_button_tag;
extern long fltk_box_tag;
extern long fltk_check_button_tag;
extern long fltk_light_button_tag;
extern long fltk_repeat_button_tag;
extern long fltk_return_button_tag;
extern long fltk_round_button_tag;
extern long fltk_valuator_tag;
extern long fltk_adjuster_tag;
extern long fltk_counter_tag;
extern long fltk_dial_tag;
extern long fltk_roller_tag;
extern long fltk_slider_tag;
extern long fltk_value_input_tag;
extern long fltk_value_output_tag;
extern long fltk_clock_tag;
extern long fltk_round_clock_tag;
extern long fltk_input_base_tag;
extern long fltk_chart_tag;
extern long fltk_choice_tag;
extern long fltk_menu_button_tag;
extern long fltk_color_chooser_tag;
extern long fltk_input_tag;
extern long fltk_float_input_tag;
extern long fltk_int_input_tag;
extern long fltk_secret_input_tag;
extern long fltk_multiline_input_tag;
extern long fltk_output_tag;

extern void fltk_fl_init ();
extern void fltk_widget_init ();
extern void fltk_menu_init ();
extern void fltk_menu_bar_init ();
extern void fltk_browser_base_init ();
extern void fltk_browser_init ();
extern void fltk_hold_browser_init ();
extern void fltk_multi_browser_init ();
extern void fltk_select_browser_init ();
extern void fltk_group_init ();
extern void fltk_tile_init ();
extern void fltk_window_init ();
extern void fltk_button_init ();
extern void fltk_box_init ();
extern void fltk_check_button_init ();
extern void fltk_light_button_init ();
extern void fltk_repeat_button_init ();
extern void fltk_return_button_init ();
extern void fltk_round_button_init ();
extern void fltk_valuator_init ();
extern void fltk_adjuster_init ();
extern void fltk_counter_init ();
extern void fltk_dial_init ();
extern void fltk_roller_init ();
extern void fltk_slider_init ();
extern void fltk_value_input_init ();
extern void fltk_value_output_init ();
extern void fltk_clock_init ();
extern void fltk_round_clock_init ();
extern void fltk_input_base_init ();
extern void fltk_input_init ();
extern void fltk_float_input_init ();
extern void fltk_int_input_init ();
extern void fltk_secret_input_init ();
extern void fltk_multiline_input_init ();
extern void fltk_chart_init ();
extern void fltk_choice_init ();
extern void fltk_color_chooser_init ();
extern void fltk_menu_button_init ();
extern void fltk_output_init ();

extern void fltk_fl_subclass (char*, long);
extern void fltk_widget_subclass (char*, long);
extern void fltk_menu_subclass (char*, long);
extern void fltk_menu_bar_subclass (char*, long);
extern void fltk_browser_base_subclass (char*, long);
extern void fltk_browser_subclass (char*, long);
extern void fltk_hold_browser_subclass (char*, long);
extern void fltk_multi_browser_subclass (char*, long);
extern void fltk_select_browser_subclass (char*, long);
extern void fltk_group_subclass (char*, long);
extern void fltk_tile_subclass (char*, long);
extern void fltk_window_subclass (char*, long);
extern void fltk_button_subclass (char*, long);
extern void fltk_box_subclass (char*, long);
extern void fltk_check_button_subclass (char*, long);
extern void fltk_light_button_subclass (char*, long);
extern void fltk_repeat_button_subclass (char*, long);
extern void fltk_return_button_subclass (char*, long);
extern void fltk_round_button_subclass (char*, long);
extern void fltk_valuator_subclass (char*, long);
extern void fltk_adjuster_subclass (char*, long);
extern void fltk_counter_subclass (char*, long);
extern void fltk_dial_subclass (char*, long);
extern void fltk_roller_subclass (char*, long);
extern void fltk_slider_subclass (char*, long);
extern void fltk_value_input_subclass (char*, long);
extern void fltk_value_output_subclass (char*, long);
extern void fltk_clock_subclass (char*, long);
extern void fltk_round_clock_subclass (char*, long);
extern void fltk_input_base_subclass (char*, long);
extern void fltk_input_subclass (char*, long);
extern void fltk_int_input_subclass (char*, long);
extern void fltk_float_input_subclass (char*, long);
extern void fltk_secret_input_subclass (char*, long);
extern void fltk_multiline_input_subclass (char*, long);
extern void fltk_color_chooser_subclass (char*, long);
extern void fltk_menu_button_subclass (char*, long);
extern void fltk_choice_subclass (char*, long);
extern void fltk_chart_subclass (char*, long);
extern void fltk_output_subclass (char*, long);

extern void gfltk_register(SCM);
extern SCM  gfltk_lookup(Fl_Widget *);
extern SCM  gfltk_lookup2(Fl_Widget *, long);
extern SCM  gfltk_get_callback(Fl_Widget *);
extern void gfltk_set_callback(Fl_Widget *, SCM);
extern void gfltk_remove(SCM);
extern void gfltk_class_register(long, long);
extern int  gfltk_type_p(SCM, long);

#endif
