class Gfltk;

class GfltkArray
{
 public:
  GfltkArray()
    {
      _size = 0; 
      _data = NULL; 
    }

  GfltkArray(long n) 
    {
      _size = 0;
      _data = NULL;
      append(n);
    }

  ~GfltkArray() { reset(); }
  Gfltk *& first() { return _data[0]; }
  Gfltk *& last() { return _data[_size-1]; }
  Gfltk *& operator[](long i) { return _data[i]; }

  Gfltk *& append(long s) 
    {
      Gfltk** t;
      t = new Gfltk*[_size+s];
      for ( register long i=0; i<_size; i++)
	t[i] = _data[i];
      if (_size > 0) 
	delete[] _data;
      _data = t;
      _size = _size + s;
      return _data[_size-s];
    }

  Gfltk *& append() { return append(1); }

  void remove(long n, long s)
    {
      Gfltk** t;
      register long i;
      
      t = new Gfltk*[_size - s];
      
      for (i=0; i<n; i++)
	t[i] = _data[i];
      
      for (i=n+s; i<_size; i++)
	t[i-s] = _data[i];
      
      delete[] _data;
      _data = t;
      _size = _size - n + s;
    }
  
  void remove(long n) { remove (_size-n, n); }
  void shrink(long s) { remove (_size - s, s); }
  
  void shrink()
    {
      Gfltk** t;
   
      _size--;
      t = new Gfltk*[_size];
      
      for (register long i=0; i<_size; i++)
	t[i] = _data[i];
      
      delete[] _data;
      _data = t;
    }

  void reset ()
    {
      delete[] _data;
      _data = NULL;
      _size = 0;
    }

  Gfltk*& insert(long n, long s)
    {
      Gfltk** t;
      register long i;
      
      t = new Gfltk*[_size+s];

      for (i=0; i<n; i++)
	t[i] = _data[i];
      
      for (i=n+s; i<_size; i++)
	t[i] = _data[i-s];
      
      delete[] _data;
      _data = t;
      _size = _size - n + s;
      return _data[n];
    }

  long size() { return _size; }

  void resize(long s) { remove (s, _size-s); }

  Gfltk** buffer() { return _data; }

  void operator = (GfltkArray &a2)
    {
      reset();
      append(a2.size());
      
      for ( register long i = 0; i < a2.size(); i++) 
        _data[i] = a2[i];
    }

 private:
  Gfltk ** _data;
  long _size;
};

